Attribute VB_Name = "modQueue"
Option Explicit
Public Declare Function SetTimer Lib "user32" (ByVal hwnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
Public Declare Function KillTimer Lib "user32" (ByVal hwnd As Long, ByVal nIDEvent As Long) As Long
Private QueueTimer As Long
Public QueueCount As Long
Private Queue As New clsQueue
Public Sub AddQ(Message As String)
    Queue.Enqueue Message
    ProcessQueue
End Sub
Public Sub ClearQueue()
    Queue.ClearQueue
End Sub
Private Sub ProcessQueue()
        If (Queue.Time <> 0) Then
            If (QueueCount - Queue.Time >= 0) Then
                    QueueCount = QueueCount - Queue.Time
                    AddChat vbGreen, "Time Wait: " & Queue.Time & " - Message: " & Queue.Dequeue
                    If QueueTimer = 0 Then
                        StartQueue 100
                    End If
            Else
                    If QueueTimer = 0 Then
                        StartQueue Queue.Time
                    End If
            End If
        End If
End Sub
Public Sub StartQueue(Tick As Long)
    StopQueue
    QueueTimer = SetTimer(0, 0, Tick, AddressOf Elasped)
End Sub
Public Sub UpdateQueueCount()
    QueueCount = QueueCount + 100
    If QueueCount >= 17000 Then
        Call StopQueue
        QueueCount = 17000
    End If
End Sub
Public Sub StopQueue()
    QueueTimer = KillTimer(0, QueueTimer)
    QueueTimer = 0
End Sub

Public Function Elasped() As Long
    Call UpdateQueueCount
    Call ProcessQueue
End Function
